/*  Copyright (C) 1996-2001  Martin Vicente			      -*- c -*-
    This file is part of the eXtended C Library (XCLIB).

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library (see the file COPYING.LIB).
    If not, write to the Free Software Foundation, Inc.,
    59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.		     */


/****  Project : eXtended C Library (XCLIB)
    *  Purpose : CIRCULAR SINGLY LINKED LIST WITH DUMMY NODE
    *  Language: ANSI C
    *  File    : demo_CListD-3.c
    *  Author  : Martin Vicente <martin@vicente.org>
    *
    ****/


#include <stdio.h>

#include <xc/CListD.h>
#include <xc/xalloc.h>

typedef struct node *Node;
typedef struct list *List;

struct node
{
    Node next;
    int  data;
};

struct list
{
    Node link;
};

int main()
{
    List l;
    Node n;
    int  i;

    l = xnew(List);
    l->link = xnew(Node);
    CLD_INIT(l);

    for (i = 1; i <= 10; i++)
    {
	(n = xnew(Node))->data = i;

	CLD_APPEND(l, n);
    }

    CLD_FWD_ACTION(l, printf(" %02d", __node->data); );
    putchar('\n');
    CLD_BWD_ACTION(l, printf(" %02d", __node->data); );
    putchar('\n');

    for (n = CLD_FIRST(l); n; n = CLD_NEXT(l, n)) printf(" %02d", n->data);
    putchar('\n');

    CLD_PLAST(l, n); while (n) { printf(" %02d", n->data); CLD_PPREV(l, n, n); }
    putchar('\n');

    CLD_CLEAN(l, xfree(__node); );

    xfree(l->link);
    xfree(l);

    return 0;
}


/* End of file */
