/*  Copyright (C) 1996-2001  Martin Vicente			      -*- c -*-
    This file is part of the eXtended C Library (XCLIB).

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library (see the file COPYING.LIB).
    If not, write to the Free Software Foundation, Inc.,
    59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.		     */


/*  XCLIB 0.3	BOOL:		BOOLEAN TYPE				     */


#ifndef __XC_BOOL_H
#define __XC_BOOL_H


/* eXtended C Library: */
#include <xc/version.h>		/* VERSION OF EXTENDED C LIBRARY	     */


#if defined __cplusplus || defined bool || __bool_true_false_are_defined
#warning "`bool' type already defined!"
#warning "CAUTION USING BOOL FUNCTIONS"
#else
#define	_XC_BOOL_IS_CHAR
#endif


#if !defined __cplusplus && defined _XC_BOOL_IS_CHAR

typedef unsigned char bool;

#define bool	bool
#define false	((bool)0)
#define true	((bool)1)

#endif

#if !defined __cplusplus && defined _XC_BOOL_IS_ENUM

enum bool { false, true };

typedef enum bool bool;

#define bool	bool
#define false	false
#define true	true

#endif

#ifdef __cplusplus

#ifdef __GNUG__
#ifdef _XC_BOOL_IS_ENUM
#error "Incompatibility with GNU C++ bool type"
#endif
#else
#error "Check compatibility with C++ bool type"
#endif

#else

#undef	FALSE
#define FALSE	false
#undef	TRUE
#define TRUE	true

#endif


extern char  __xcint(force_bool);
#ifdef __PARANOID__
static char *__xclib(local_bool) __unused = &__xcint(force_bool);
#endif


#endif /* XC BOOL HEADER */


/*------------------------------/ END OF FILE /------------------------------*/
