/*  XCLIB - a set of C functions for general purposes		      -*- c -*-
    Copyright (C) 1996-2001  Martin Vicente

    This file is part of the eXtended C Library (XCLIB).

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library (see the file COPYING.LIB).
    If not, write to the Free Software Foundation, Inc.,
    59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.		     */


/*|+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++|*\
  |  Martin Vicente, 1996-2001
  |
  | Project : XCLIB (eXtended C Library)
  | Purpose : POSIX TIME SERVICE
  | Version : 0.3
  | Language: ANSI C
  | File    : time/get.c
  | Author  : Martin VICENTE <martin@vicente.org>
\*|+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++|*/


/*****************************************************************************\

 EDOM    Math argument out of domain of function
 ERANGE  Math result not representable

 [English]

 [French]

   A terme, l'appel  fix_time() ne sera ralis que dans des conditions
   particulires (comme un problme caus par le dmon NTP).

\*****************************************************************************/


#include "time/common.h"

/* FROM XFree86: xc/lib/Xt/NextEvent.c
 */
/* Some systems running NTP daemons are known to return strange usec
 * values from gettimeofday.
 */
#ifndef NEEDS_NTPD_FIXUP
# if defined sun || defined MOTOROLA || defined sco324 || (defined __osf__ && defined __alpha)
#  define NEEDS_NTPD_FIXUP 1
# else
#  define NEEDS_NTPD_FIXUP 0
# endif
#endif

int get_time(struct timeval *t)
{
    assert(t != NULL);

    if (gettimeofday(t, NULL) == -1) return ERROR;

    assert(t->tv_usec >= 0 && t->tv_usec < MILLION);
    assert(t->tv_sec  >= 0);

#if 1
    if (fix_time(t) == ERROR) return ERROR;
#endif

    return OK;
}


/* End Of File */
