/*  XCLIB - a set of C functions for general purposes		      -*- c -*-
    Copyright (C) 1996-2001  Martin Vicente

    This file is part of the eXtended C Library (XCLIB).

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library (see the file COPYING.LIB).
    If not, write to the Free Software Foundation, Inc.,
    59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.		     */


/*|+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++|*\
  |  Martin Vicente, 1996-2001
  |
  | Project : XCLIB (eXtended C Library)
  | Purpose : TRACE FACILITY (internals)
  | Version : 0.3
  | Language: ANSI C
  | File    : trace/intern.h
  | Author  : Martin VICENTE <martin@vicente.org>
\*|+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++|*/


#include <stdarg.h>
#include <stdio.h>

#include <xc/cdecl.h>

struct info
{
    const char *faci;
    const char *file;
    int         line;
};

void __xcint(trace)(const struct info *info, const char *format, va_list vargs);
void __xcint(trace_in)(const struct info *info, const char *function, va_list vargs);
void __xcint(trace_out)(const struct info *info, const char *function, va_list vargs);

void __xcint(trace_set_output)(FILE *stream);


/* END OF FILE */
