############################################################## -*- makefile -*-
#
#	Copyright (C) 1996-2001  Martin Vicente
#	This file is part of the eXtended C Library (XCLIB).
#
#	This library is free software; you can redistribute it and/or
#	modify it under the terms of the GNU Library General Public
#	License as published by the Free Software Foundation; either
#	version 2 of the License, or (at your option) any later version.
#
#	This library is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#	Library General Public License for more details.
#
#	You should have received a copy of the GNU Library General Public
#	License along with this library (see the file COPYING.LIB).
#	If not, write to the Free Software Foundation, Inc.,
#	59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
#
###############################################################################
#
#	HELP TARGET
#
# Warning: This is an include file for GNU makefiles only.
#
#	Project : "Les outils de Martin"
#	Purpose : `help' target for GNU makefile
#	File    : utils/help.mk
#	Version : 1.1
#	Language: GNU Make
#	Author  : Martin Vicente
#	Contact : martin@vicente.org (or martin.vicente@free.fr)
#	Revision: Mon, 14 May 2001
#
###############################################################################

ifneq (,)
This makefile requires GNU Make.
endif

ifndef   __UTILS_HELP_MK
override __UTILS_HELP_MK := OK

#==============================================================================

override UTILS ?= $(HOME)/devel/utils

include $(UTILS)/color.mk		# DISPLAY COLORIZATION
include $(UTILS)/usage.mk		# USAGE TARGET
include $(UTILS)/help-options.mk	# HELP-OPTIONS TARGET
include $(UTILS)/help-colors.mk		# HELP-COLORS TARGET

#====( DEFINITIONS )

override _1  := "Environment:"
override _2  :=
override _3  := "    VERBOSE  = No/Yes  For verbose mode"
override _4  := "    XLOG     =         Inhibit xmessage"
override _5  :=
override _6  := "Targets:"
override _7  :=
override _8  := "    [default] . . . . .  Build archive and programs"
override _9  := "    bin, tests, demos .  Build programs (all, tests, or demos)"
override _10 := "    archive . . . . . .  Build archive file only"
override _11 := "    library . . . . . .  Build shared library only"
override _12 := "    [un]install . . . .  [Un]Install all"
override _13 := "    [un]install-incs  .  [Un]Install headers"
override _14 := "    [un]install-libs  .  [Un]Install libraries"
override _15 := "    [un]install-archive  [Un]Install archive file"
override _16 := "    [un]install-library  [Un]Install shared library"
override _17 := "    [un]install-man . .  [Un]Install manuals"
override _18 := "    [un]install-bin . .  [Un]Install programs"
override _19 := "    [un]install-src . .  [Un]Install examples"
override _20 := "    [un]install-demos .  [Un]Install programs/examples"
override _21 := "    [un]install-full  .  [Un]Install with multiple options"
override _22 := "    clean . . . . . . .  Remove programs"
override _23 := "    realclean . . . . .  Remove binaries"
override _24 := "    distclean . . . . .  Clean distribution"
override _25 := "    dist  . . . . . . .  Build a source distribution"
override _26 := "    help  . . . . . . .  This help"
override _27 := "    help-options  . . .  How to setup options"
override _28 := "    help-colors . . . .  How to setup colors"
override _29 := "    version . . . . . .  Print package version"

override count := 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23\
		  24 25 26 27 28 29

override HELP := $(foreach n, $(count), $(_$n)\\n)

#====( RULES )

help: usage ; @ $(ECHO_E) $(green)$(HELP)$(reset)

.PHONY: help

#==============================================================================

endif  # __UTILS_HELP_MK

# [END OF FILE]
